﻿using Styx.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LootCrystals
{
    public class LCSettings : Styx.Helpers.Settings
    {
        private static LCSettings _instance;

        public LCSettings()
            : base(System.IO.Path.Combine(CharacterSettingsDirectory, "LootCrystals.xml")) 
        {

        }
        public static LCSettings Instance
        {
            get { return _instance ?? (_instance = new LCSettings()); }
        }

        [Setting, DefaultValue(90)]
        [System.ComponentModel.Category("Range")]
        [System.ComponentModel.DisplayName("Max Gather Range")]
        [System.ComponentModel.Description("Will try to gather Crytals inside this Range")]
        public int MaxGatherRange { get; set; }

		[Setting, DefaultValue(true)]
        [System.ComponentModel.Category("Swimming")]
        [System.ComponentModel.DisplayName("Disable while Swimming")]
        [System.ComponentModel.Description("Will NOT try to gather if we are swimming when set to True")]
        public bool MeSwimming { get; set; }
    }
}