﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.POI;
using Styx.Plugins;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LootCrystals
{
    public class LootCrystals : HBPlugin
    {
        static string lastInformationMSG;
        private static bool _lootingCrystal = false;
        private static DateTime _crystalLootingStarted;
        private static List<Crystal> _crystals = new List<Crystal>();
        private static WoWObject _currentCrystal;
        public override string Author { get { return "ElPargo"; } }
        public override string Name { get { return "Loot Crystals"; } }
        public override Version Version { get { return new Version(1, 0, 3); } }
		public override string ButtonText { get { return "Settings"; } } 
        public override bool WantButton { get { return true; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
		public static string usedBot { get { return BotManager.Current.Name.ToUpper(); } }
        
        public override void Pulse()
        {
            if (!Styx.StyxWoW.IsInGame || Me == null || !Me.IsValid || !Me.IsAlive || StyxWoW.Me.ZoneId != 7637 || (Me.IsSwimming && LCSettings.Instance.MeSwimming)) 
            { 
                return; 
            } 
			
			if (!infoLogReset.IsRunning || (infoLogReset.IsRunning && infoLogReset.ElapsedMilliseconds > 2000)) { lastInformationMSG = ""; infoLogReset.Reset(); }
            var c = ObjectManager.GetObjectsOfTypeFast<WoWObject>().FirstOrDefault(f => IsEntryACrystal(f.Entry) && f.Distance < LCSettings.Instance.MaxGatherRange);

            if (c != null && !_lootingCrystal && MoveBot && !Blacklist.Contains(c.Guid, BlacklistFlags.All))
            {
                if (c != null && (!StyxWoW.Me.Combat || (StyxWoW.Me.Combat && StyxWoW.Me.Mounted)))
                {
                    infoLog("Looting Crystal: " + c.GetObjectName() + " : " + c.Entry + "(" + _crystals.FirstOrDefault(crys => crys.ID == c.Entry)?.Name + ")");
                    BotPoi.Current = new BotPoi(c, PoiType.Harvest, NavType.Fly);
                }
            }
        }
		
		public override void OnEnable()
        {
            base.OnEnable();
            _crystals.Clear();
            _crystals.Add(new Crystal() { ID = 252774, Name = "Ancient Mana Crystal" });
            _crystals.Add(new Crystal() { ID = 245941, Name = "Warp Cache" });
            _crystals.Add(new Crystal() { ID = 252884, Name = "Glimmering Treasure Chest" });
            _crystals.Add(new Crystal() { ID = 252831, Name = "Glimmering Treasure Chest" });
            _crystals.Add(new Crystal() { ID = 252822, Name = "Glimmering Treasure Chest" });
            _crystals.Add(new Crystal() { ID = 252432, Name = "Shimmering Ancient Mana Cluster" });
			_crystals.Add(new Crystal() { ID = 252446, Name = "Shimmering Ancient Mana Cluster" });
			_crystals.Add(new Crystal() { ID = 252447, Name = "Shimmering Ancient Mana Cluster" });
			_crystals.Add(new Crystal() { ID = 252448, Name = "Shimmering Ancient Mana Cluster" });
			_crystals.Add(new Crystal() { ID = 252449, Name = "Shimmering Ancient Mana Cluster" });
			_crystals.Add(new Crystal() { ID = 252450, Name = "Shimmering Ancient Mana Cluster" });
			_crystals.Add(new Crystal() { ID = 254006, Name = "Enchanted Burial Urn" });
			_crystals.Add(new Crystal() { ID = 254009, Name = "Volatile Leyline Crystal" });
			_crystals.Add(new Crystal() { ID = 254008, Name = "Kyrtos's Research Notes" });
			_crystals.Add(new Crystal() { ID = 248407, Name = "Kel'danath's Manaflask" });
			_crystals.Add(new Crystal() { ID = 254023, Name = "Arcane Power Unit" });

            infoLog("Enabled");
        }

        public override void OnDisable()
        {
            base.OnDisable();
            infoLog("Disabled");
        }
		
        private static Stopwatch infoLogReset = new Stopwatch();
        public void infoLog(string Message, params object[] args)
        {
            if (Message == lastInformationMSG) { return; }

            Logging.Write(System.Windows.Media.Colors.LightBlue, "[LootCrystal]: {0}", Message, args);
            lastInformationMSG = Message;
        }
		
		public static void debugLog(string message, params object[] args) 
        { 
            Logging.WriteQuiet(message, args); 
        } 

		bool IsEntryACrystal(uint id)
        {
            foreach (var item in _crystals)
            {
                if (item.ID == id)
                {
                    return true;
                }

            }
            return false;
        }
        
		public override void OnButtonPress() 
        { 
            SettingsFormGrid frm = new SettingsFormGrid();
            frm.ShowDialog();
            LCSettings.Instance.Save();
        }
		
	public static bool MoveBot
        {
            get
            {
                return usedBot.Contains("QUEST") || usedBot.Contains("GATHER") || usedBot.Contains("GRIND") || usedBot.Contains("ARCH");
            }
        }
		
	}
	
    public class Crystal
    {
        public uint ID { get; set; }
        public string Name { get; set; }
    }
}
